c     Copyright (C)
c     2021 Mésotar
c     
c     This file must be used under the terms of the CeCILL license.
c     This source file is licensed as described in the file COPYING, which
c     you should have received as part of this distribution.  The terms
c     are also available at
c     http://www.cecill.info/licences/Licence_CeCILL_V2.1-en.txt
c
      subroutine read_seed(seed)
      implicit none
      include 'max.inc'
c     I/O
      integer seed
c     temp
      integer ios
      character*(Nchar_mx) seedfile
      character*(Nchar_mx) oldseedfile
c     label
      character*(Nchar_mx) label
      label='subroutine read_seed'

      seedfile='./config/seed'
      open(11,file=trim(seedfile),status='old',iostat=ios)
      if (ios.ne.0) then ! file not found
         call error(label)
         write(*,*) 'file could not be found:'
         write(*,*) trim(seedfile)
         stop
      endif
      read(11,*) seed
      close(11)

      oldseedfile='./config/old_seed'
      open(12,file=trim(oldseedfile))
      write(12,*) seed
      close(12)

      return
      end



      subroutine write_seed()
      implicit none
      include 'max.inc'
c     temp
      integer seed
      character*(Nchar_mx) seedfile
c     label
      character*(Nchar_mx) label
      label='subroutine write_weed'

      seedfile='./config/seed'

      call generate_1seed(seed)

      open(11,file=trim(seedfile))
      write(11,*) seed
      close(11)

      return
      end



      subroutine generate_1seed(seed)
      implicit none
      include 'max.inc'
c     I/O
      integer seed
c     temp
      double precision r
c     label
      character*(Nchar_mx) label
      label='subroutine generate_1seed'
c
c     Purpose: to generate a seed that "zufalli" will use
c     to initialize the random number generator "zufall"
c
c     The seed must be 0 < seed < 31328
c
      call random_gen(r)
      seed=int(r*31329)

      return
      end
